package com.steerinfo.dil.controller;

import com.alibaba.fastjson.JSON;
import com.steerinfo.dil.service.ITmstruckLeaveFactoryResultService;
import com.steerinfo.dil.service.impl.OffSiteTransportationServiceImpl;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import com.steerinfo.route.config.ImageFileUtils;
import com.steerinfo.route.service.impl.RouteServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartRequest;

import java.util.*;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.TimeUnit;

@Api("厂外运输接口")
@RestController
@RequestMapping("/${api.version}/pathDisplay")
public class OffSiteTransportationController extends BaseRESTfulController {
    @Autowired
    private ITmstruckLeaveFactoryResultService tmstruckLeaveFactoryResultService;
    @Autowired
    private RouteServiceImpl routeService;
    @Autowired
    ColumnDataUtil columnDataUtil;
    @Autowired
    ImageFileUtils imageFileUtils;


    @Autowired
    OffSiteTransportationServiceImpl offSiteTransportationService;
    @ApiOperation("保存路径")
    @PostMapping("/savePath")
    public CompletableFuture<String> savePath() throws Exception {

        Map<String, Object> parem=tmstruckLeaveFactoryResultService.getTruckFactoryResult("WYSDD2022032400030239");
        parem.put("turnOf","0");
        return routeService.createTotalResult(parem);
        //运输订单号：orderNumber、车牌号：capacityNumber、出厂时间:resultOutGateTime、预警开关：turnOf、发货地址:shipperName、收货地址:receiveAddress
        //初始化请求参数
//        HashMap<String,Object> mapValue=new HashMap<>();
//        mapValue.put("orderNumber","WYSDD2021091000000001");
//        mapValue.put("capacityNumber","豫SB6238");
//        mapValue.put("resultOutGateTime","2021-11-17 14:20:19");
//        mapValue.put("turnOf","0");
//        mapValue.put("shipperName","四川达州钢铁集团有限");
//        mapValue.put("receiveAddress","长沙市");
//        return routeService.createTotalResult(mapValue);
    }
    @ApiOperation("全路径查询")
    @PostMapping("/fullPath")
    public Object fullPath(String orderNumber) throws Exception {
        //运输订单号：orderNumber、车牌号：capacityNumber、出厂时间:resultOutGateTime、预警开关：turnOf、发货地址:shipperName、收货地址:receiveAddress
        //初始化请求参数
        HashMap<String,Object> mapValue=new HashMap<>();
        mapValue.put("orderNumber",orderNumber);
        return routeService.fullPathVisualization(mapValue);
    }

    @ApiOperation("查询在途运输")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer")
    })
    @PostMapping("/getInTransitTransportation")
    public RESTfulResult getInTransitTransportation(@RequestBody Map<String,Object> mapValue,
                                                    @RequestParam(required = true,defaultValue = "468",name = "apiId")Integer apiId,
                                                    @RequestParam(required = false,defaultValue = "1",name = "pageNum")Integer pageNum,
                                                    @RequestParam(required = false,defaultValue = "20",name = "pageSize")Integer pageSize
                                                    )
    {
        List<Map<String,Object>> filter= offSiteTransportationService.getInTransitTransportation(mapValue);
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String,Object>> list= offSiteTransportationService.getInTransitTransportation(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, filter,list);
        return success(pageList);
    }

    @PostMapping(value = "/addTmstruckReceiptResult", headers = "content-type=multipart/form-data")
    public synchronized RESTfulResult addTmstruckReceiptResult(@RequestPart("request") MultipartRequest request, Integer num, String orderNumber, String resultArrivalAddress, Integer imgcount3, Integer imgcount4) throws Exception {

        Map<String,Object> map = new HashMap<String,Object>();
        map.put("orderNumber",orderNumber);
        map.put("resultArrivalAddress",resultArrivalAddress);
        Integer orderStatus = offSiteTransportationService.getOrderStatus(map);
        if (orderStatus!=null&&orderStatus==2){
            return failed();
        }
        //多选图片变量
        List<String> fourFiles=new ArrayList<String>();

        MultipartFile file=null;
        int fourcount=1;
        for (int i=0;i<num;i++){
            file=request.getFile("file"+i);
            if (i==0){
                String url=imageFileUtils.updateFile(file);
                map.put("url1",url);
            }else if (i==1){
                String url=imageFileUtils.updateFile(file);
                map.put("url2",url);
            }else if (imgcount3==1&&i==2){
                String url=imageFileUtils.updateFile(file);
                map.put("url3",url);

            }else {
                String url=imageFileUtils.updateFile(file);
                fourFiles.add(url);
                fourcount++;
            }
        }
        map.put("fourFiles",fourFiles);
        Integer resTfulResult = offSiteTransportationService.addTmstruckReceiptResult(map);
//        if (!resTfulResult.getData().toString().equals("4")){
//            //保存路线
//            String redisJson = (String) redisTemplate.opsForValue().get(prefixOrder+":"+orderNumber);
//            HashMap mapValue = JSON.parseObject(redisJson, HashMap.class);
//            String json = zhongJiaoXingLu.visualRoute(mapValue);
//            ViewVisualization to=null;
//            if (json!=null){
//                //设置60天后过期
//                Calendar calendar=Calendar.getInstance();
//                long agoTime= calendar.getTime().getTime();
//                calendar.add(Calendar.MONTH,2);
//                long lateTime= calendar.getTime().getTime();
//                long saveTime=(lateTime-agoTime)/1000;
//                redisTemplate.opsForValue().set(prefixLine+":"+orderNumber, json, saveTime, TimeUnit.SECONDS);
//                //删除订单
//                redisTemplate.delete(prefixOrder+":"+orderNumber);
//                redisTemplate.delete(prefixOrder+":"+orderNumber+suffix);
//                //添加运输距离
//                to= (ViewVisualization) DataConversionTool.jsonToBean(json,ViewVisualization.class);
//
//            }else {
//                System.out.println("数据为空");
//                System.out.println(orderNumber);
//                HashMap<String,Object> hashMap=new HashMap();
//                hashMap.put("orderNumber",orderNumber);
//                RESTfulResult startAndEndCapacityNumber = tmsFeign.getStartAndEndCapacityNumber(hashMap);
//                System.out.println(hashMap);
//                System.out.println(startAndEndCapacityNumber);
//                HashMap<String,Object> resultMap= (HashMap<String, Object>) startAndEndCapacityNumber.getData();
//                if (resultMap!=null){
//                    json= getPathJSON(resultMap.get("capacityNumber").toString(),resultMap.get("resultOutGateTime").toString());
//
//
//                    if (json!=null&&!json.equals("")){
//                        to= (ViewVisualization) DataConversionTool.jsonToBean(json,ViewVisualization.class);
//                    }
//                }
//            }
//
//            if (to!=null&&to.getResult()!=null&&to.getResult().getRunDistance()!=null){
//                Map<String,Object> ordermap=new HashMap<>();
//                ordermap.put("orderNumber",orderNumber);
//                ordermap.put("orderMileage",to.getResult().getRunDistance()==null?"1":to.getResult().getRunDistance());
//                omsFeign.insertOrderMileage(ordermap);
//
//            }else {
//                if (to!=null&&to.getStatus()==1006){
//
//                    Map<String,Object> ordermap=new HashMap<>();
//                    ordermap.put("orderNumber",orderNumber);
//                    ordermap.put("orderMileage","-1");
//                    omsFeign.insertOrderMileage(ordermap);
//                }else if (to!=null&&to.getStatus()==1001){
//                    Map<String,Object> ordermap=new HashMap<>();
//                    ordermap.put("orderNumber",orderNumber);
//                    ordermap.put("orderMileage","1");
//                    omsFeign.insertOrderMileage(ordermap);
//                } else {
//                    System.out.println("不清楚的状态值");
//                    System.out.println(to);
//                    Map<String,Object> ordermap=new HashMap<>();
//                    ordermap.put("orderNumber",orderNumber);
//                    ordermap.put("orderMileage","-1");
//                    omsFeign.insertOrderMileage(ordermap);
//                }
//
//            }
       // }


        return null;
    }
}